
function ultimatecontact_getPrevDay(day){
	switch(day) {
		case 'monday':
			return 'sunday';
		case 'tuesday':
			return 'monday';
		case 'wednesday':
			return 'tuesday';
		case 'thursday':
			return 'wednesday';
		case 'friday':
			return 'thursday';
		case 'saturday':
			return 'friday';
		case 'sunday':
			return 'saturday';
	}
}

function getAddress(){
	return jQuery('#addr_str').val() + ', ' + jQuery('#addr_suburb').val() + ', ' + jQuery('#addr_region').val() + ', ' + jQuery('#addr_country').val();
}

jQuery(document).ready(function($) {
	
	 $( "#recipient_list" ).sortable({
		 placeholder: "ui-state-highlight",
			 handle: ".drag_handle",
			 cursor: "move" ,
		stop: function( event, ui ) {
			$('.last_recipient').removeClass('last_recipient');
			$('#recipient_list .ucp_recipient:last').addClass('last_recipient');
		 }
	 });

	$('.last_recipient input').live('focus', function() {
		var row = $('<div>' + $('.last_recipient').html() + '</div>').addClass('ucp_recipient').addClass('last_recipient');
		
		$(row).find('.recipient_email').attr('value', '');
		$(row).find('.recipient_label').attr('value', '');
		$('.last_recipient').removeClass('last_recipient');
		$('#recipient_list').append($(row).wrap('<div>').parent().html());
	});

	$("#search_addr").geocomplete({
		map: ".map_canvas",
		//location: getAddress(),
		markerOptions: {
			draggable: true
		}
	}).bind("geocode:result", function(event, result){
		if(typeof(result.adr_address) == "undefined") {
			return;
		}
		var addr = $('<div>' + result.adr_address + '</div>');
		$('#addr_str').val(addr.find('.street-address').text());
		$('#addr_suburb').val(addr.find('.locality').text());
		$('#addr_region').val(addr.find('.region').text());
		$('#addr_postcode').val(addr.find('.postal-code').text());
		$('#addr_country').val(addr.find('.country-name').text());
	});

	$('#update_map').click(function(){
		var ultimate_contact_address = getAddress();
		$("#search_addr").geocomplete('find', ultimate_contact_address);
	});

	if($('#addr_str').val().length > 1 ||$('#addr_suburb').val().length > 1 || $('#addr_region').val().length >1 || $('#addr_country').val().length > 1) {
		var ultimate_contact_address = getAddress();
		$("#search_addr").geocomplete('find', ultimate_contact_address);
	}

	$('.day_opening_time').timepicker({
		timeFormat: 'hh:mm tt',
		stepHour: 1,
		stepMinute: 10,
		stepSecond: 10
	});


	$('.copy_above_times').click(function() {
		var day = $(this).attr('id');
		day = day.replace('copy_above_times_', '');

		var prev_day = ultimatecontact_getPrevDay(day);
		$('#open_' + day + '_start').val($('#open_' + prev_day + '_start').val());
		$('#open_' + day + '_end').val($('#open_' + prev_day + '_end').val());
	});

	$('.copy_above_times').each(function() {
		var day = $(this).attr('id');
		day = day.replace('copy_above_times_', '');
		var prev_day = ultimatecontact_getPrevDay(day);
		$(this).attr('value', 'Copy ' + prev_day.charAt(0).toUpperCase() + prev_day.slice(1) + ' times');
	});
	var checkbox_check = function() {
		var day = $(this).attr('id').replace('closed_','').toLowerCase();
		if ($(this).is(':checked')) {
			$('#open_'+day+'_start').attr('disabled', true).attr('readonly', true).val('');
			$('#open_'+day+'_end').attr('disabled', true).attr('readonly', true).val('');
			$('#copy_above_times_'+day).attr('disabled', true).attr('readonly', true);
		} else {
			$('#open_'+day+'_start').attr('disabled', false).attr('readonly', false);
			$('#open_'+day+'_end').attr('disabled', false).attr('readonly', false);
			$('#copy_above_times_'+day).attr('disabled', false).attr('readonly', false);
		}
	};

	$('.closed_checkbox').change(checkbox_check);
	$('.closed_checkbox').each(checkbox_check);
	
});