<?php
/*
Plugin Name: Ultimate Contact Page (shared on wplocker.com)
Plugin URI: http://www.jordie.org/ultimate_contact.php
Description: Plugin providing full contact page functionality including contact form, address with map (using a format Google recognises) and opening hours.(Purchased from CodeCanyon.net)
Version: 2.1
Author: Jordie Bodlay
Author URI: http://www.jordie.org
License: Commercial License
*/


// __('','ultimate-contact');
// _e('','ultimate-contact');


global $ultimatecontact_db_version, $ultimatecontact_options;

$ultimatecontact_db_version = "2.1";

load_plugin_textdomain('ultimate-contact', false, basename( dirname( __FILE__ ) ) . '/lang' );


add_action( 'admin_menu',		'ultimate_contact_page_menu' );
add_action( 'admin_init',		'ultimate_contact_page_init' );
add_action( 'admin_head',		'custom_post_type_icon' );
add_action( 'wp_ajax_nopriv_ultimate_contact_submit',	'ucf_submit_form' );
add_action( 'wp_ajax_ultimate_contact_submit',			'ucf_submit_form' );
add_action( 'plugins_loaded',	'ultimate_contact_page_update_db_check');


// Shortcodes
$GLOBALS['ucp_map_shortcode'] = 'ultimate_contact_map';
$GLOBALS['ucp_openhours_shortcode'] = 'ultimate_contact_openhours';
$GLOBALS['ucp_address_shortcode'] = 'ultimate_contact_address';
$GLOBALS['ucp_form_shortcode'] = 'ultimate_contact_form';

// Shortcodes for widgets
if (!is_admin()) {
  add_filter('widget_text', 'ucp_widget_shortcode', 11);
}

add_shortcode( 'ultimate_contact_page', 	'ucp_show_contact_page' );
add_shortcode( $GLOBALS['ucp_map_shortcode'],		'ucp_show_contact_map');
add_shortcode( $GLOBALS['ucp_openhours_shortcode'],	'ucp_show_openhours' );
add_shortcode( $GLOBALS['ucp_form_shortcode'], 	'ucp_show_contact_form' );
add_shortcode( $GLOBALS['ucp_address_shortcode'], 	'ucp_show_address' );

register_activation_hook(__FILE__, 'install_ultimate_contact_page');
register_activation_hook(__FILE__, 'install_ultimate_contact_human');
register_activation_hook(__FILE__, 'install_ultimate_contact_page_data');

global $run_shortcode_init;

$run_shortcode_init = false;

function ucp_shortcode_init() {
	if($run_shortcode_init) {
		return;
	}
	load_contact_page_data();
	$run_shortcode_init = true;
}

function ucf_submit_form() {
//	ini_set('display_errors', 'On');
//	error_reporting(E_ALL);

	global $ultimatecontact_options, $wpdb;

	load_contact_page_data();

	header( "Content-Type: application/json" );

	$my_test = $wpdb->get_row($wpdb->prepare( "SELECT * FROM ". $wpdb->prefix . "ultimatecontact_humantest WHERE testkey = %s", $_POST['test_key']) );

	if($ultimatecontact_options['field_human'] == 'yes') {
		if($ultimatecontact_options['antispamtype'] == 'recaptcha') {
			require_once(dirname(__FILE__) . '/lib/recaptchalib.php');
			  $resp = recaptcha_check_answer ($ultimatecontact_options['recaptcha_privatekey'],
											$_SERVER["REMOTE_ADDR"],
											$_POST["recaptcha_challenge_field"],
											$_POST["recaptcha_response_field"]);

			  if (!$resp->is_valid) {
				// What happens when the CAPTCHA was entered incorrectly
				echo json_encode( array( 'success' => false, 'message' => __('The answer to the human test was not correct.','ultimate-contact'), 'reason' => 'badtest' ) );
				die();
			  }
		}	else {
			if(!is_object($my_test) || (int)$my_test->result !== (int)$_POST['human_test'] || empty($_POST['test_key'])) {
				echo json_encode( array( 'success' => false, 'message' => __('The answer to the human test was not correct.','ultimate-contact'), 'reason' => 'badtest' ) );
				die();
			}
		}
	}

	if(isset($_POST['subject']) && !empty($_POST['subject'])) {
		$subject = $_POST['subject'];
	} else {
		$subject = __("Contact Form Submission", 'ultimate-contact');
	}

	if(empty($_POST['message']) || empty($_POST['email'])) {
		echo json_encode( array( 'success' => false, 'message' => __('Please incluide an email address and message.', 'ultimate-contact'), 'reason' => 'missingfields' ) );
		die();
	}

	$message = "No message sent.";
	if(isset($_POST['message']) && !empty($_POST['message'])) {
		$message = $_POST['message'];
	}

	$recipients = json_decode(@$ultimatecontact_options['recipients'], true);
	if(is_array($recipients)) {
		$request = (int)$_POST['request'];
		$recipient = $recipients[$request]['email'];
	} else {
		$recipient = get_bloginfo('admin_email');
	}

	// get the submitted parameters
	$headers = array();
	$headers[] = 'From: ' . str_replace(array("\r", "\n", "\n", "\t", ",", ";"), '', $_POST['email']). "\r\n";
	$result = wp_mail($recipient, $subject, $message, $headers);
	$mailchimp = null;

	if(isset($_POST['subscribe']) && $_POST['subscribe'] == 'yes') {
		require_once(dirname(__FILE__) . '/lib/MCAPI.class.php');
		$api = new MCAPI(@$ultimatecontact_options['mailchimp_apikey']);

		if($api->listSubscribe(@$ultimatecontact_options['mailchimp_listid'], $_POST['email'], '') === true) {
			// It worked!
			$mailchimp = true;
		}else{
			// An error ocurred, return error message
			$mailchimp = false;
		}
	}

	$wpdb->query( $wpdb->prepare( "DELETE FROM ". $wpdb->prefix . "ultimatecontact_humantest WHERE testkey = %s", $_POST['test_key']));

	// generate the response
	echo json_encode( array( 'success' => true, 'mailchimp' => $mailchimp ));
	/*
	// debug stuff
	'message' => "reason: ". $result,
		'subject'=> $subject,
		'message'=> $_POST['message'],
		'from'=> $_POST['email'],
		'sentto' =>  @$ultimatecontact_options['email_addr']) );*/

	die();
}


function custom_post_type_icon() {
	?>
	<style type="text/css" media="screen">
	#toplevel_page_ultimate_contact_page .wp-menu-image {
		background: url("<?php echo plugin_dir_url( __FILE__ ) . '/imgs/admin_icon_16.png'; ?> ") no-repeat 0 -32px !important;
	}

	#toplevel_page_ultimate_contact_page:hover .wp-menu-image, #toplevel_page_ultimate_contact_page.wp-has-current-submenu .wp-menu-image {
		background-position: 0 0 !important;
	}

	</style>
	<?php
}

function UCF_generateRandomString($length = 10) {
	return substr(str_shuffle("0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"), 0, $length);
}

function ucp_show_openhours() {
	global $ultimatecontact_options;
	global $wpdb;

	ucp_shortcode_init();

	wp_register_style( 'ultimate_contact_page_customcss', plugins_url('/css/frontend.css', __FILE__) );
	wp_enqueue_style( 'ultimate_contact_page_customcss' );

	ob_start();
	include(dirname(__FILE__) . "/section_openhours.php");
	$content = ob_get_contents();
	ob_end_clean();

	return $content;

}

function ucp_show_address() {
	global $ultimatecontact_options;
	global $wpdb;

	ucp_shortcode_init();

	wp_register_style( 'ultimate_contact_page_customcss', plugins_url('/css/frontend.css', __FILE__) );
	wp_enqueue_style( 'ultimate_contact_page_customcss' );

	ob_start();
	include(dirname(__FILE__) . "/section_address.php");
	$content = ob_get_contents();
	ob_end_clean();

	return $content;
}

function ucp_localize() {
	wp_localize_script( 'ultimate_contact_submit', 'UltimateContact', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ), 'exitFullscreen' => __( 'Exit Fullscreen' ) ) );
}

function ucp_show_contact_form() {
	global $ultimatecontact_options;
	global $wpdb;

	ucp_shortcode_init();

	wp_enqueue_script( 'ultimate_contact_submit', plugin_dir_url( __FILE__ ) . 'js/form.js', array( 'jquery' ) );
	ucp_localize();


	wp_register_style( 'ultimate_contact_page_customcss', plugins_url('/css/frontend.css', __FILE__) );
	wp_enqueue_style( 'ultimate_contact_page_customcss' );


	// generate a math question for the human test
	$number1 = rand(1,10);
	$number2 = rand(1,10);
	$result = $number1 + $number2;
	$test_key = UCF_generateRandomString();

	$insert_query = "INSERT INTO ".$wpdb->prefix ."ultimatecontact_humantest ( testkey, result, createdtime) VALUES (%s, %s, %s )";
	$wpdb->query( $wpdb->prepare( $insert_query , $test_key, $result, time()) );

	$del_query = "DELETE FROM ".$wpdb->prefix ."ultimatecontact_humantest WHERE createdtime < " . (time() - (86400*3));
	$wpdb->query( $del_query );

	ob_start();
	include(dirname(__FILE__) . "/section_contactform.php");
	$content = ob_get_contents();
	ob_end_clean();

	return $content;
}



function ucp_widget_shortcode($content){
	global $map_shortcode, $ultimatecontact_options;
	$content = do_shortcode($content);
	return $content;
}


function ucp_show_contact_map($attr=''){
	global $ultimatecontact_options;
	global $wpdb;

	ucp_shortcode_init();

	wp_enqueue_script( 'google-maps', 'https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false&libraries=places' );
	wp_enqueue_script( 'ultimate_contact_page_geocodescript', plugins_url('/js/jquery.geocomplete.js', __FILE__) );
	wp_enqueue_script( 'ultimate_contact_submit', plugin_dir_url( __FILE__ ) . 'js/form.js', array( 'jquery' ) );
	ucp_localize();
	wp_register_style( 'ultimate_contact_page_customcss', plugins_url('/css/frontend.css', __FILE__) );
	wp_enqueue_style( 'ultimate_contact_page_customcss' );

	$map_height = '400px';
	$map_width = '100%';
	if(is_array($attr) && isset($attr['height'])) {
		$map_height = $attr['height'];
		if(strpos($map_height, "px") === false && strpos($map_height, "%") === false) {
			$map_height .= 'px';
		}
	}

	if(is_array($attr) && isset($attr['width'])) {
		$map_width = $attr['width'];
		if(strpos($map_width, "px") === false && strpos($map_width, "%") === false) {
			$map_width .= 'px';
		}
	}

	ob_start();
	include(dirname(__FILE__) . "/section_map.php");
	$content = ob_get_contents();
	ob_end_clean();

	return $content;
}

function ucp_show_contact_page($content) {
	global $ultimatecontact_options;
	global $wpdb;

	wp_enqueue_script( 'ultimate_contact_submit', plugin_dir_url( __FILE__ ) . 'js/form.js', array( 'jquery' ) );
	wp_localize_script( 'ultimate_contact_submit', 'UltimateContact', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
	wp_enqueue_script( 'google-maps', 'https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false&libraries=places' );
	wp_enqueue_script( 'ultimate_contact_page_geocodescript', plugins_url('/js/jquery.geocomplete.js', __FILE__) );

	wp_register_style( 'ultimate_contact_page_customcss', plugins_url('/css/frontend.css', __FILE__) );
	wp_enqueue_style( 'ultimate_contact_page_customcss' );

	ucp_shortcode_init();

	// generate a math question for the human test
	$number1 = rand(1,10);
	$number2 = rand(1,10);
	$result = $number1 + $number2;
	$test_key = UCF_generateRandomString();

	$insert_query = "INSERT INTO ".$wpdb->prefix ."ultimatecontact_humantest ( testkey, result, createdtime) VALUES (%s, %s, %s )";
	$wpdb->query( $wpdb->prepare( $insert_query , $test_key, $result, time()) );

	$del_query = "DELETE FROM ".$wpdb->prefix ."ultimatecontact_humantest WHERE createdtime < " . (time() - (86400*3));
	$wpdb->query( $del_query );


	if(!empty($ultimatecontact_options['mailchimp_apikey'])) {
//		require_once(dirname(__FILE__) .'/lib/MCAPI.class.php');
//		$api = new MCAPI($ultimatecontact_options['mailchimp_apikey']);
//		$lists = $api->lists();
//		if(is_array($lists) && is_array($lists['data']) && sizeof($lists['data']) > 0) {
//			$haslists = true;
//		}
	}


	ob_start();
	include(dirname(__FILE__) . "/contact_page.php");
	$content = ob_get_contents();
	ob_end_clean();
	return $content;
}

function ultimate_contact_page_update_db_check() {
	global $ultimatecontact_db_version;
	if (get_option('ultimatecontact_db_version') != $ultimatecontact_db_version) {
		install_ultimate_contact_page();
		install_ultimate_contact_page_data();
	}
}


function load_contact_page_data() {
	global $wpdb, $ultimatecontact_options;
	$rows = $wpdb->get_results( "SELECT * FROM  ".$wpdb->prefix ."ultimatecontact " );
	foreach($rows as $row) {
		$ultimatecontact_options[$row->name] = $row->value;
	}
}


function install_ultimate_contact_page_data() {
	global $wpdb;
	global $ultimatecontact_db_version;
	$insert_query = "INSERT INTO ".$wpdb->prefix ."ultimatecontact ( name, value) VALUES (%s, %s )";


		$wpdb->query( $wpdb->prepare( $insert_query , 'org_name', '') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'org_type', 'LocalBusiness') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'recipients','') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'phone_num', '') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'fax_num', '') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'fb_page', '') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'twitter_user', '') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'search_addr', '') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'addr_str', '') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'addr_suburb', '') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'addr_region', '') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'addr_postcode','') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'addr_country', '') );

		$wpdb->query( $wpdb->prepare( $insert_query , 'field_name', 'yes') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'field_email', 'yes') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'field_subject', 'yes') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'field_request', 'yes') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'field_phone', 'yes') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'field_human', 'yes') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'field_message', 'yes') );

		$wpdb->query( $wpdb->prepare( $insert_query , 'mailchimp_label', 'Join our mailing list!') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'mailchimp_apikey', '') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'mailchimp_listid', '0') );

		$wpdb->query( $wpdb->prepare( $insert_query , 'antispamtype', 'math') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'recaptcha_publickey', '') );
		$wpdb->query( $wpdb->prepare( $insert_query , 'recaptcha_privatekey', '') );

		$dow = array('monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday', 'sunday');
		foreach($dow as $day) {
			$wpdb->query( $wpdb->prepare( $insert_query , 'open_' . $day .'_start', '') );
			$wpdb->query( $wpdb->prepare( $insert_query , 'open_' . $day .'_end', '') );
			$wpdb->query( $wpdb->prepare( $insert_query , 'closed_' . $day, 'no') );
		}

		$features = array('disable_mailchimp', 'disable_openhours', 'disable_contactform', 'disable_address', 'disable_map');
		foreach($features as $feature) {
			$wpdb->query( $wpdb->prepare( $insert_query , $feature, 'no') );
		}
}

function install_ultimate_contact_human() {
	global $wpdb;
	global $ultimatecontact_db_version;
		$table_name = $wpdb->prefix . "ultimatecontact_humantest";
		$sql = "CREATE TABLE ". $table_name ." (
			testkey VARCHAR(255) DEFAULT '' NOT NULL,
			result tinytext NOT NULL,
			createdtime VARCHAR(255) DEFAULT '' NOT NULL,
			KEY  (testkey)
		);";

		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
}


function install_ultimate_contact_page() {
	global $wpdb;
	global $ultimatecontact_db_version;
	$installed_ver = get_option( "ultimatecontact_db_version" );

	if( $installed_ver != $ultimatecontact_db_version ) {
		$table_name = $wpdb->prefix . "ultimatecontact";

		if((float)$installed_ver < 2.1 && (float)$installed_ver > 0.9) {
			$res = $wpdb->get_results("SHOW INDEX FROM ".$table_name." WHERE `Key_name` LIKE 'name%'");

			foreach($res as $row) {
				$wpdb->query("DROP INDEX `{$row->Key_name}` ON `{$row->Table}`");
			}
		}

		
		$sql = "CREATE TABLE ". $table_name ." (
			id int(11) NOT NULL AUTO_INCREMENT,
			name VARCHAR(255) DEFAULT '' NOT NULL,
			value text NOT NULL,
			UNIQUE KEY (name),
			PRIMARY KEY  (id)
		);";


		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
		
		if(empty($installed_ver)) {
			add_option("ultimatecontact_db_version", $ultimatecontact_db_version);
		} else { 
			update_option( "ultimatecontact_db_version", $ultimatecontact_db_version );
		}
	}
}


function ultimate_contact_page_init() {
}



function ultimate_contact_page_menu() {
	add_object_page( 'Ultimate Contact Page', 'Contact Page', 'manage_options', 'ultimate_contact_page', 'ultimate_contact_page','div');
}

function ultimate_contact_page() {
	global $ultimatecontact_options, $ultimatecontact_db_version;
	if ( !current_user_can( 'manage_options' ) )  {
		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
	}

	wp_enqueue_script( 'jquery-ui', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.9.2/jquery-ui.min.js' );
	wp_enqueue_script( 'google-maps', 'https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false&libraries=places' );
	wp_enqueue_script( 'ultimate_contact_page_script', plugins_url('/js/jquery-ui-timepicker-addon.js', __FILE__) );
	wp_enqueue_script( 'ultimate_contact_page_geocodescript', plugins_url('/js/jquery.geocomplete.js', __FILE__) );
	wp_enqueue_script( 'ultimate_contact_page_adminjs', plugins_url('/js/admin.js', __FILE__) );

	wp_register_style( 'jquery-ui-css', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.9.2/themes/ui-lightness/jquery-ui.css' );
	wp_register_style( 'ultimate_contact_custom_admin_css', plugins_url('/css/admin.css', __FILE__) );
	wp_enqueue_style( 'jquery-ui-css' );
	wp_enqueue_style( 'ultimate_contact_custom_admin_css' );


	if(isset($_POST['save'])) {
		global $wpdb;
		// $insert_query = "INSERT INTO ".$wpdb->prefix ."ultimatecontact ( name, value) VALUES (%s, %s )";

		$insert_query = "UPDATE ".$wpdb->prefix ."ultimatecontact set value=%s where name=%s";

		$update = array(
			'org_name' => $_POST['org_name'],
			'phone_num' => $_POST['phone_num'],
			'fax_num' => $_POST['fax_num'],
			'fb_page' => $_POST['fb_page'],
			'twitter_user' => str_replace('@' , '' ,$_POST['twitter_user']),
			'search_addr' => $_POST['search_addr'],
			'addr_str' => $_POST['addr_str'],
			'addr_suburb' => $_POST['addr_suburb'],
			'addr_region' => $_POST['addr_region'],
			'addr_postcode' => $_POST['addr_postcode'],
			'addr_country' => $_POST['addr_country'],
			'org_type' => $_POST['org_type'],
			'mailchimp_label' => $_POST['mailchimp_label'],
			'mailchimp_apikey' => trim($_POST['mailchimp_apikey']),
			'mailchimp_listid' => trim($_POST['mailchimp_listid']),
			'recaptcha_publickey' => trim($_POST['recaptcha_publickey']),
			'recaptcha_privatekey' => trim($_POST['recaptcha_privatekey']),
			'antispamtype' => $_POST['antispamtype'],
		);

		$dow = array('monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday', 'sunday');
		foreach($dow as $day) {
				$update['open_' . $day .'_start'] = $_POST['open_' . $day .'_start'];
				$update['open_' . $day .'_end'] = $_POST['open_' . $day .'_end'];
			$closed = "no";

			if(isset($_POST['closed_' . ucfirst($day)]) && $_POST['closed_' . ucfirst($day)] == "yes") {
				//closed today
				$update['closed_' . $day] = 'yes';
			}else{
				$update['closed_' . $day] = 'no';
			}
		}

		$features = array('disable_mailchimp', 'disable_openhours', 'disable_contactform', 'disable_address', 'disable_map',
						'field_name', 'field_email', 'field_subject', 'field_request', 'field_phone', 'field_human', 'field_message'
					);
		foreach($features as $feature) {
			if(isset($_POST[$feature]) && $_POST[$feature] == "yes") {
				//closed today
				$update[$feature] = 'yes';
			}else{
				$update[$feature] = 'no';
			}
		}

		$recipients = array();

		foreach($_POST['recipient_email'] as $key => $email) {
			$label = $_POST['recipient_label'][$key];
			if(empty($label) && empty($email)) {
				continue;
			}
			$recipients[] = array('label'=> $label, 'email'=>$email);
		}

		$update['recipients'] = json_encode($recipients);

		foreach($update as $name=>$value) {
			$wpdb->query( $wpdb->prepare( $insert_query , $value, $name));
		}

		echo '<div class="updated">
			<p>' . __('Plugin shared on WPLOCKER.COM - Changes to your Contact Page have been saved.', 'ultimate-contact') .'</p>
		</div>';
	}

	load_contact_page_data();
	$haslists = false;
	$lists = array();

	if(!empty($ultimatecontact_options['mailchimp_apikey'])) {
		require_once(dirname(__FILE__) .'/lib/MCAPI.class.php');
		$api = new MCAPI($ultimatecontact_options['mailchimp_apikey']);
		$lists = $api->lists();
		if(is_array($lists) && is_array($lists['data']) && sizeof($lists['data']) > 0) {
			$haslists = true;
		}
	}

	include(dirname(__FILE__) . '/admin_display.php');
}

